using Uno;
using Uno.Graphics;
using Uno.Platform;
using Uno.Collections;
using Fuse;
using Fuse.Controls;
using Fuse.Triggers;
using Fuse.Resources;
using Android;
using Uno.Compiler.ExportTargetInterop;

[ForeignInclude(Language.Java,
				"android.app.Activity",
				"android.content.Intent",
				"android.net.Uri",
				"android.os.Bundle",
				"android.provider.MediaStore",
				"java.io.File")]
public partial class MainView
{
	void ClickPlay(object a1, EventArgs a2)
	{
		var intent = MakeMyIntent(); // [0]
		if (intent!=null)
		{
			ActivityUtils.StartActivity(intent, OnResult);  // [1]
		} else {
			debug_log "Failed to make intent.";
		}
	}

	extern(android) void OnResult(int resultCode, Java.Object intent, object info)  // [2]
	{
		debug_log "Success!: " + resultCode + " - " + intent + "\n";
	}

	[Foreign(Language.Java)]
	static extern(android) Java.Object MakeMyIntent()
	@{
		try {
			String fileName = "JPEG_TEST";
			String ext = ".jpg";
			File storageDir = com.fuse.Activity.getRootActivity().getExternalFilesDir(null);
			File photoFile = File.createTempFile(fileName, ext, storageDir);
			Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
			Bundle bdl = new Bundle();
			bdl.putParcelable(MediaStore.EXTRA_OUTPUT, Uri.fromFile((File)photoFile));
			takePictureIntent.putExtras(bdl);
			return takePictureIntent;
		} catch (Exception ex) {
			return null;
		}
	@}

	extern(!android) void OnResult(int resultCode, object intent)
	{
	}

	static extern(!android) object MakeMyIntent()
	{
		return null;
	}
}
